%%% Monte Carlo Dynamic Classifier tool - MCDC tool
% http://www.ismvideo.org/NDE0UP/MCDCtool/en/index.html

% Copyright (C) 2014 Gareth W. Peters, Tomoko Matsui, Francois Septier, and Akira Tamamori

% This program is free software; you can redistribute it and/or modify it under the terms
% of the GNU General Public License as published by the Free Software Foundation; either
% version 2 of the License, or (at your option) any later version.

% This program is distributed in the hope that it will be useful, but WITHOUT ANY
% WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE.  See the GNU General Public License for more details.

% You should have received a copy of the GNU General Public License along with this
% program; if not, see <http://www.gnu.org/licenses/>.

%
% PMCMCParticleFilter.m
%

classdef PMCMCParticleFilter < ParticleFilter

  methods (Access = public)
    
    function this = PMCMCParticleFilter(x0, xaux, u, y, f, h, q, r, N, K)
      this = this@ParticleFilter(x0, xaux, u, y, f, h, q, r, N, K);
      
      T = size(y, 1);
      % Generate the trajectories from ancestor indices
      ind = this.ancestorIndicies(:, T);
      for(t = T-1:-1:1)
          this.Particles(:, t) = this.Particles(ind, t);
          ind = this.ancestorIndicies(ind, t);
      end
    end
    
  end

end
